CREATE OR REPLACE FUNCTION getOrgIDByFullID(org_kind IN VARCHAR2,
                                            full_ID  IN VARCHAR2)
  RETURN VARCHAR2 IS
  RESULT VARCHAR2(32);
BEGIN
  DECLARE
    idx_kind  INTEGER;
    idx_split INTEGER;
  
  BEGIN
    idx_kind := INSTR(full_ID, '.' || org_kind, -1);
    IF (idx_kind > 0) THEN
      idx_split := INSTR(full_ID, '/', idx_kind - length(full_ID) - 1);
      RESULT    := SUBSTR(full_ID, idx_split + 1, idx_kind - idx_split - 1);
    END IF;
  END;

  RETURN(RESULT);
END getOrgIDByFullID;
/
