CREATE OR REPLACE FUNCTION transferAttachmentFromX3(key_field IN VARCHAR2,
                                                  key_value IN VARCHAR2)
  RETURN VARCHAR2 IS
  RESULT CLOB;
  /*
  
  ת X3 -> X5
  ****ıTDocRelevancy(X3) SA_DocNode(X5)
  
  Σ
    key_field X3 
    key_value ҵ
  أ
    result
  
  Ҫõݸʽ
  [
    {
      "docID":"C5254BC2F870000151FDBA2C1F8014D6",
      "docName":"test.doc",
      "size":26112,
      "fileID":"6-root",
      "docPath":"/root/76b9d258-4975-4b0d-b7ba-875efe244224",
      "time":"2012-03-07T15:27:50.806Z"
    },
    {
      "docID":"C5254BC651C0000116C712331E2019CE",
      "docName":"X5.java",
      "size":6891,
      "fileID":"5-root",
      "docPath":"/root/76b9d258-4975-4b0d-b7ba-875efe244224",
      "time":"2012-03-07T15:28:04.380Z"
    }
  ]
  */
BEGIN
  DECLARE
    -- α꣬ҵݹĵ
    CURSOR doc_cursor IS
      SELECT x5Doc.sID,
             x5Doc.sDocName,
             x5Doc.sSize,
             x5Doc.sFileID,
             x5Doc.sDocPath,
             x5Doc.sLastWriteTime
      FROM   TDocRelevancy x3DocLink
      JOIN   SA_DocNode x5Doc ON x3DocLink.fDocGUID = x5Doc.sID
      WHERE  (key_field IS NULL OR x3DocLink.fKey0 = key_field)
      AND    (x3DocLink.fKeyValue0 = key_value);
  
  BEGIN
    -- 
    FOR doc_row IN doc_cursor LOOP
      -- ŷָ
      IF (RESULT IS NOT NULL) THEN
        RESULT := RESULT || ',';
      END IF;
    
      RESULT := RESULT || '{' 
        || '"docID": "' || doc_row.sID || '",' 
        || '"docName": "' || doc_row.sDocName || '",' 
        || '"size": ' || doc_row.sSize || ',' 
        || '"fileID": "' || doc_row.sFileID || '",' 
        || '"docPath": "' || doc_row.sDocPath || '",' 
        || '"time": "' || to_char(doc_row.sLastWriteTime, 'YYYY-MM-DD"T"HH24:MI:SS".000Z"') || '"' 
        || '}';
    END LOOP;
  END;

  IF (RESULT IS NOT NULL) THEN
    RESULT := '[' || RESULT || ']';
  END IF;

  RETURN(RESULT);

END transferAttachmentFromX3;
/
